<?php
error_reporting(0);// Turn off all error reporting

$version = 0.2;
	
class TagAllyForWPFunction
{
	var $baseurl;
	var $siteurl;
	var $home;
	var $install_directory;
	var $tbtags;
	var $tbpost2tag;
	
	var $maxfont;
	var $minfont;
	
	var $tagsys;

	function TagAllyForWPFunction()
	{
		global $table_prefix, $wpdb, $version;
		
		$this->baseurl = "/wordpress";
		$this->siteurl = get_option('siteurl');
		$this->home = get_option('home');
		$this->install_directory = "/tagally-for-wp";
		$this->tbtags = $table_prefix . "tags";
		$this->tbpost2tag = $table_prefix . "post2tag";
		
		$this->maxfont = 28;
		$this->minfont = 10;
		
		$this->tagsys = ereg("^2.3", get_bloginfo('version'));
		
		$installed_build = get_option("TAFWPVersion");
		if ($installed_build == '')
		 $installed_build = 0;
		 
		if(!$this->tagsys)
		{
			$sql = <<<SQL
				CREATE TABLE IF NOT EXISTS $this->tbtags (
					tag_ID int(11) NOT NULL auto_increment,
				  tag varchar(255) NOT NULL default '',
				  PRIMARY KEY  (tag_ID)
				) ENGINE=MyISAM
SQL;
			$wpdb->query($sql);
	
			$sql = <<<SQL
				CREATE TABLE IF NOT EXISTS $this->tbpost2tag (
				  rel_id int(11) NOT NULL auto_increment,
				  tag_id int(11) NOT NULL default '0',
				  post_id int(11) NOT NULL default '0',
				  ip_address varchar(15),
				  PRIMARY KEY  (rel_id)
				) ENGINE=MyISAM;
SQL;
			$wpdb->query($sql);
			
			$sql = "Describe $this->tbtags slug";
			$fields = $wpdb->get_results($sql);
			if(is_null($fields[0]))
			{
				$sql = <<<SQL
					ALTER TABLE $this->tbtags
					  ADD slug varchar(255) NOT NULL default ''
SQL;
				$wpdb->query($sql);
				
				$sql = "SELECT * from $this->tbtags";
				$tags = $wpdb->get_results($sql);
				foreach($tags as $tag)
				{
					$slug = sanitize_title($tag->tag);
					$tagslug_check = $wpdb->get_var("SELECT tag_ID FROM $this->tbtags WHERE slug = '$slug' AND tag_ID != $tag->tag_ID LIMIT 1");
					if($tagslug_check)
					{
						$suffix = 2;
						do {
							$alt_slug = $slug . "-$suffix";
							$tagslug_check = $wpdb->get_var("SELECT tag_ID FROM $this->tbtags WHERE slug = '$alt_slug' AND tag_ID != $tag->tag_ID LIMIT 1");
							$suffix++;
						} while ($tagslug_check);
						$slug = $alt_slug;
					}
					if(!$wpdb->query("UPDATE $this->tbtags SET slug='$slug' WHERE tag_ID=$tag->tag_ID"))
						return;
				}
			}
		}
	
		add_option("TAFWPShowpopuptooltips","Yes","selecting yes to pop up tooltip when moving mouse cursor onto a tag displayed in tagcloud");
		add_option("TAFWPMostpopularFont","28","");
		add_option("TAFWPLeastpopularFont","10","");
		update_option("TAFWPVersion",$version);
	}
	
	function GetTagsForPost($postid,$limit)
	{
		global $wpdb, $tafwp;
		$sql = "SELECT DISTINCT t.tag, t.slug FROM $tafwp->tbtags t INNER JOIN $tafwp->tbpost2tag p2t ON p2t.tag_id = t.tag_id INNER JOIN $wpdb->posts p ON p2t.post_id = p.ID AND p.ID=$postid ORDER BY t.tag ASC limit $limit";
		$tags = $wpdb->get_results($sql);
		return $tags;
	}

	function GetFrequencyOfTags()
	{
		global $wpdb,$tafwp;
		if ($tafwp->tagsys)
		{
			$sql = "select sum(count) from $wpdb->term_taxonomy where taxonomy = 'post_tag'";
		}
		else
		{
			$sql = "select count(*) from $tafwp->tbpost2tag p2t inner join $wpdb->posts p on p2t.post_id = p.ID WHERE post_date_gmt < '" . current_time('mysql', 1)."' and post_type = 'post'";
		}
		return $wpdb->get_var($sql);
	}
	
	function GetPopularTags($limit)
	{
		global $wpdb, $tafwp;
		$now = current_time('mysql', 1);
		$frequency = $tafwp->GetFrequencyOfTags();
		if ($tafwp->tagsys)
		{
			$sql = <<<SQL
			select t.name as tag, t.term_id, t.slug, tt.count as c, (tt.count/$frequency*100) as weight
			from $wpdb->terms t inner join $wpdb->term_taxonomy tt on t.term_id = tt.term_id
			where tt.taxonomy = 'post_tag' and tt.count > 0
			group by t.name
			order by t.name desc
			limit $limit
SQL;
		}
		else
		{
			$sql = <<<SQL
			select t.tag, t.slug, t.tag_id, count(p2t.post_id) as c, (count(p2t.post_id)/$frequency*100) as weight
			from $tafwp->tbtags t inner join $tafwp->tbpost2tag p2t on t.tag_id = p2t.tag_id
							  inner join $wpdb->posts p on p2t.post_id = p.ID
			where post_date_gmt < 'now' and post_type = 'post'
			group by t.tag
			having c > 0
			order by tag desc
			limit $limit
SQL;
	 }
		return $wpdb->get_results($sql);
	}
	
	function GetTagFontSize($maxc,$minc,$weight)
	{
		$mpfont = get_option("TAFWPMostpopularFont");
		$lpfont = get_option("TAFWPLeastpopularFont");
#		$fontsize = intval($weight/100*($mpfont-$lpfont)+$lpfont);
		if($maxc == $minc)
			$fontsize = $lpfont;
		else
			$fontsize = intval(($weight-$minc)/($maxc-$minc)*($mpfont-$lpfont)+$lpfont);
		return $fontsize."px";
	}
	
	function GetTagColor($weight)
	{
		$colors = array("#000000","#ff9999","#cc9900","#669966","#336666","#9966cc","#ff33ff","#660066",
            "#990066","#666666","#ff3333","#999933","#00cc00","#003399","#6600cc","#cc00cc",
            "#ff0099","#663333","#999999","#990000","#33cccc","#006600","#3366ff","#333366",
            "#000099","#003300","#999966","#cc6600","#330000","#000033","#663366","#993333",
            "#ff6633","#6666ff","#ff6666","#66cc66","#cc00cc","#333300","#000066","#666633");
     return $colors[$weight%40];
	}
	
	function GetTagLink($tag)
	{
		global $wp_rewrite;
		if (empty($wp_rewrite->permalink_structure))
		{
			$file = get_option('home') . '/';
			$taglink = $file . '?tag=' . $tag;
		}
	  else
	  {
			$taglink = '/tag/'.$tag;
			$taglink = get_option('home') . user_trailingslashit($taglink, 'category');
		}
		return $taglink;
	}
	
	function SortByAlphabetical($taga, $tagb)
	{
		 return strcmp($taga->tag,$tagb->tag);
	}
	
	function GetPostsForTagTemplates($tags)
	{
	}
	
	function ShowPopularTags($limit)
	{
		global $tafwp;
		$poptags = $tafwp->GetPopularTags($limit);
		$showpopup = get_option("TAFWPShowpopuptooltips");
		if($poptags)
		{
			usort($poptags,array("TagAllyForWPFunction","SortByAlphabetical"));
			$taghtml = "<div style='margin:0px;padding:5px'>";
			
			if($showpopup == "Yes")
			{
				$scriptStr = "var shiStrArr = new Array(";
				$scriptID = "var shiIDArr = new Array(";
			}
			$maxc = $poptags[0]->c;
			$minc = $maxc;
			foreach($poptags as $poptag)
			{
				if($maxc < $poptag->c)  $maxc = $poptag->c;
				if($minc > $poptag->c)  $minc = $poptag->c;
			}
			$i=0;
			foreach($poptags as $poptag)
			{
				$fontsize = $tafwp->GetTagFontSize($maxc,$minc,$poptag->c);
				$color = $tafwp->GetTagColor($i);
				if ($tafwp->tagsys)
				{
					$taglink = get_tag_link($poptag->term_id);
				}
				else
				{
					$param = urlencode($poptag->slug);
					$taglink = "$tafwp->siteurl/index.php?tag=$param";
				}
				$taghtml .= " <a id='taly_$i' href=\"$taglink\"";
				if($showpopup == "Yes")
				{
					$taghtml .= " onmouseover=\"try{dropmenu(event);}catch(e){}\" onmouseout=\"try{delayhidemenu();}catch(e){}\"";
				}
				$taghtml .= " style=\"font-size:$fontsize; color:$color ;display:inline;text-decoration:none;background-image:none;background-color:transparent;border:0px;margin:0pt;padding:0px;\">".$poptag->tag."</a>";
				$taghtml .= "&nbsp;&nbsp;";
				
				if($showpopup == "Yes")
				{
					$tag = addslashes($poptag->tag);
					$scriptStr .= "'$tag',";
					$scriptID .= "'-1',";
				}
				
				$i++;
			}
			
			if($showpopup == "Yes")
			{
				$scriptStr = substr($scriptStr,0,-1).");";
				$scriptID = substr($scriptID,0,-1).");";
				$taghtml .= "<script>$scriptStr$scriptID</script>";
			}
			
			$taghtml .= "</div>";
			
			echo $taghtml;
		}
	}
	
	function admin_menu_tag_option()
	{
		if (function_exists('add_options_page'))
		{
			add_options_page('TagALLYTag Options', 'TagALLY', 8, basename(__FILE__), Array('TagAllyForWPFunction','tag_option_panel'));
		}
		if (function_exists('add_management_page'))
		{
			add_management_page('TagALLYTag Management', 'TagALLY', 8, basename(__FILE__), Array('TagAllyForWPFunction','tag_manage_panel'));
		}
	}
	
	function tag_manage_panel()
	{
		global $wpdb, $tafwp, $version;
		if ($_POST["export"] == "completed")
		{
			$from = get_option('blogname');
			if ($tafwp->tagsys)
			{
				$sql = <<<SQL
				select p.id as id,p.post_title as post_title,p.post_content as post_content,p.guid as guid,p.post_date as post_date,t.name as tag
				from $wpdb->posts p
				inner join $wpdb->term_relationships tr on p.id = tr.object_id and p.post_status = 'publish' and p.post_type = 'post'
				inner join $wpdb->term_taxonomy tt on tt.term_taxonomy_id = tr.term_taxonomy_id and tt.taxonomy = 'post_tag'
				inner join $wpdb->terms t on t.term_id = tt.term_id
SQL;
			}
			else
			{
				$sql = "select p.id as id,p.post_title as post_title,p.post_content as post_content,p.guid as guid,p.post_date as post_date,t.tag as tag from $wpdb->posts p inner join $tafwp->tbpost2tag pt on pt.post_id = p.id and p.post_status = 'publish' and p.post_type = 'post' inner join $tafwp->tbtags t on t.tag_id = pt.tag_id";
			}
		  $posts = $wpdb->get_results($sql);
		  if($posts)
			{
				$postarr = array();
				$tagarr = array();
				foreach($posts as $p)
				{
					$time = date("Y-m-d H:i:s",strtotime($p->post_date));
					$excerpt = $tafwp->cut_str(strip_tags($p->post_content),250,"UTF-8");
					if(! isset($postarr["$p->id"]))
					{
						$guid = strip_tags($p->guid);
						$from = strip_tags($from);
						$title = strip_tags($p->post_title);
						$excerpt = strip_tags($excerpt);
						$time = strip_tags($time);
						$postarr["$p->id"] = array("guid"=>$guid,"from"=>$from,"posttitle"=>$title,"excerpt"=>$excerpt,"posttime"=>$time);
						
					}
					if(! isset($tagarr["$p->id"]))
					{
						$tagarr["$p->id"] = "$p->tag";
					}
					else
					{
						$tagarr["$p->id"] .= ",$p->tag";
					}
				}
				$data = "";
				$i = 0;
				foreach($postarr as $postid => $post)
				{
					$i += 1;
					$tags = strip_tags($tagarr[$postid]);
					if(strlen($data))
					{
							$data .= "&guid$i=".rawurlencode($post["guid"]);
							$data .= "&from$i=".rawurlencode($post["from"]);
							$data .= "&posttitle$i=".rawurlencode($post["posttitle"]);
							$data .= "&excerpt$i=".rawurlencode($post["excerpt"]);
							$data .= "&posttime$i=".rawurlencode($post["posttime"]);
							$data .= "&tags$i=".rawurlencode($tags);
					}
					else
					{
							$data = "&guid$i=".rawurlencode($post["guid"]);
							$data .= "&from$i=".rawurlencode($post["from"]);
							$data .= "&posttitle$i=".rawurlencode($post["posttitle"]);
							$data .= "&excerpt$i=".rawurlencode($post["excerpt"]);
							$data .= "&posttime$i=".rawurlencode($post["posttime"]);
							$data .= "&tags$i=".rawurlencode($tags);
					}
				}
				$fp = fsockopen("www.tagally.com", 80, $errno, $errstr, 10);
				if ($fp)
				{
					$post_data = "v=".rawurlencode($version)."&postcount=".rawurlencode($i).$data;
					$post_length = strlen($post_data);
					$out = "POST http://www.tagally.com/main/importall HTTP/1.1\r\n";
					$out .= "Host: www.tagally.com\r\n";
					$out .= "Content-Length:$post_length\r\n";
					$out .= "Content-Type:application/x-www-form-urlencoded; charset=utf-8\r\n";
					$out .= "Connection: Close\r\n\r\n";
					$out .= $post_data;
					
					$len = fwrite($fp, $out);
					while (!feof($fp))
					{
						fgets($fp, 128);
					}
					fclose($fp);
					echo "<div id=\"message\" class=\"updated fade\"><p><strong>Export posts and related tags completed.</strong></p></div>";
				}
				else
				{
						echo "<div id=\"message\" class=\"updated fade\"><p><strong>Can't connetct to www.tagally.com.</strong></p></div>";
				}
			}
			else
			{
				echo "<div id=\"message\" class=\"updated fade\"><p><strong>No any posts exported.</strong></p></div>";
			}
		}
		echo<<<HTML
			<div class="wrap">
				<h2>TagALLY-for-WP Export</h2>
				<fieldset class="options"><legend>Help!</legend><a href="$tafwp->siteurl/wp-content/plugins$tafwp->install_directory/tagally-for-wp-help.html" target="_new">help</a> | <a href="./options-general.php?page=tagally-for-wp-function.php">Options TagALLY</a></fieldset>
				<div class="narrow">
					<p>If you are using wordpress 2.3 or higher, or your blog version is lower than wordpress 2.3 but you have used UltimateTagWarrior plugins before, you can use the one-click method to export your posts and related tags.</p>
					<p>We'll only collect those publish-status posts's excerpts and url links grouped by their tags in our <a href="http://www.tagally.com">TagALLY</a> website, then make them sharable among wordpress blogs and later even anyone who accesses TagALLY website.</p>
					<form action="" method="post">
						<p class="submit"><input type="submit" name="submit" value="Export posts and related tags " />
						<input type="hidden" name="export" value="completed" />
					</p>
				</div>
			</div>
HTML;
	}
	
	function tag_option_panel()
	{
		global $tafwp;
		if ($_POST["action"] == "updated")
	  {
	  	$success = true;
	  	update_option("TAFWPShowpopuptooltips",$_POST["showpopuptooltips"]);
	  	if (!ereg("^[1-9]",$_POST["mpfont"]) && !ereg("^[1-9][0-9]}",$_POST["mpfont"]))
	  	{
	  		$success = false;
	  		echo "<div id=\"message\" class=\"updated fade\"><p><strong>Most popular font size must be single or double-digit, and the first digit can't be 0.</strong></p></div>";
	  	}
	  	else
	  	{
	  		update_option("TAFWPMostpopularFont",$_POST["mpfont"]);
	  	}
	  	if (!ereg("^[1-9]",$_POST["lpfont"]) && !ereg("^[1-9][0-9]}",$_POST["lpfont"]))
	  	{
	  		$success = false;
	  		echo "<div id=\"message\" class=\"updated fade\"><p><strong>Least popular font size must be single or double-digit, and the first digit can't be 0.</strong></p></div>";
	  	}
	  	else
	  	{
	  		update_option("TAFWPLeastpopularFont",$_POST["lpfont"]);
	  	}
	  	if ($success)
	  	{
	  		echo "<div id=\"message\" class=\"updated fade\"><p><strong>Options saved.</strong></p></div>";
	  	}
	  }
	  
		$showpopup = get_option("TAFWPShowpopuptooltips");
		$mpfont = get_option("TAFWPMostpopularFont");
		$lpfont = get_option("TAFWPLeastpopularFont");
		
		echo<<<HTML
			<div class="wrap">
				<h2>TagALLY-for-WP Options</h2>
				<fieldset class="options"><legend>Help!</legend><a href="$tafwp->siteurl/wp-content/plugins$tafwp->install_directory/tagally-for-wp-help.html" target="_new">help</a> | <a href="./edit.php?page=tagally-for-wp-function.php">Manage TagALLY</a></fieldset>
				<form method="post"> 
					<p class="submit"><input type="submit" name="Submit" value="Update Options " /></p>
					<table width="70%" cellpadding="3" cellspacing="0">
						<tr>
							<td><b>Pop up tooltips in tagcloud:</b></td>
							<td><select name="showpopuptooltips" id="showpopuptooltips">
HTML;
		 echo "<option value=\"Yes\"";
	   if ($showpopuptooltips == "Yes")
	   {
	   	 echo " selected=\"selected\"";
	   }
	   echo ">Yes</option>";
	   echo "<option value=\"No\"";	 
	   if ($showpopup == "No")
	   {
	   	 echo " selected=\"selected\"";
	   }
	   echo ">No</option>";
	   echo <<<HTML
					    </select></td>
						</tr>
						<tr>
							The font size must be single or double-digit, and the first digit can't be 0.
					  </tr>
						<tr>
							<td><b>Most popular Font:</b></td>
							<td><input name="mpfont", size="2", maxlength="2", value="$mpfont">px</td>
						</tr>
						<tr>
							<td><b>Least popular Font:</b></td>
							<td><input name="lpfont", size="2", maxlength="2", value="$lpfont">px</td>
						</tr>
					</table>
					<input type="hidden" name="action" value="updated" /> 
				</form>
		  </div>
HTML;

	}

	function edit_post_tags()
	{
		global $post, $tafwp;
		$taglist = "";
		
		if(is_object($post) && $post->ID)
		{
			$tags = $tafwp->GetTagsForPost($post->ID,10);

			if($tags)
			{
			  foreach($tags as $tag)
			  {
				  $taglist .= $tag->tag . ",";
		    }
		  	$taglist = substr($taglist, 0, -1);
		  	$taglist = preg_replace("/\"/","&quot;",$taglist);
	    }
	  }

		echo<<<HTML
		  	<h3 class="dbx-handle">Tags (comma separated list)</h3>
		  	<div class="dbx-content">
		  		<input id="tlmiftaglist" name="taglist" value="$taglist" style="width:98%" onfocus=" document.getElementById('hiddenTagList').style.display='block'"><br />
		  	</div>
HTML;

		$poptags = $tafwp->GetPopularTags(50);
		if($poptags)
		{
			usort($poptags,array("TagAllyForWPFunction","SortByAlphabetical"));
			$taghtml = "<div style=\"margin:5px;padding:5px;border:solid 1px #B3B6B0;display:none;\" id=\"hiddenTagList\">";
			$taghtml .= "<b>existing tags:</b> ";
			
			$maxc = $poptags[0]->c;
			$minc = $maxc;
			foreach($poptags as $poptag)
			{
				if($maxc < $poptag->c)  $maxc = $poptag->c;
				if($minc > $poptag->c)  $minc = $poptag->c;
			}
			
			$i = 0;
			foreach($poptags as $poptag)
			{
				$fontsize = $tafwp->GetTagFontSize($maxc,$minc,$poptag->c);//$poptag->weight
				$color = $tafwp->GetTagColor($i);
				$slashtag = preg_replace("/\"/","&quot;",$poptag->tag);
				$slashtag = preg_replace("/\\\/","&#92;&#92;",$slashtag);
				$slashtag = preg_replace("/\'/","\'",$slashtag);
				
				$taghtml .= "<a href=\"javascript:insertTag('".$slashtag."')\" style=\"font-size:$fontsize; color:$color\">".$poptag->tag."</a> ";
				$i++;
			}
			$taghtml .= "</div>";
			echo $taghtml;
		}
	}
	
	function save_post_tags($postid)
	{
		global $wpdb, $tafwp, $version;
		if ($tafwp->tagsys)
		{
			$tags = $_POST['tags_input'];
		}
		else
		{
			$tags = $_POST['taglist'];
		}
		$tagarray = explode(',',$tags);
		$taglist = "";
		
		if (!$tafwp->tagsys)
		{
			foreach($tagarray as $tag)
			{
				$tag = trim($tag);
				if($tag == "")
					continue;
				$sql = "select tag_ID from $tafwp->tbtags where tag = '$tag'";
				$tagid = $wpdb->get_var($sql);
				if(is_null($tagid))
				{
					$slug = sanitize_title($tag);
					$slug_check = $wpdb->get_var("SELECT tag_ID FROM $tafwp->tbtags WHERE slug = '$slug' LIMIT 1");
					if (!is_null($slug_check))
					{
						$alt_slug="";
						$suffix = 2;
						do
						{
							$alt_slug = $slug . "-$suffix";
							$slug_check = $wpdb->get_var("SELECT tag_ID FROM $tafwp->tbtags WHERE slug = '$alt_slug' LIMIT 1");
							$suffix++;
						} while (!is_null($slug_check));
						$slug = $alt_slug;
					}
					$sql = "insert into $tafwp->tbtags(tag,slug) values('$tag','$slug')";
					$wpdb->query($sql);
					$tagid = $wpdb->insert_id;
				}
				$sql = "select rel_id from $tafwp->tbpost2tag where tag_id = $tagid and post_id = $postid";
				if(is_null($wpdb->get_var($sql)))
				{
					$sql = "insert into $tafwp->tbpost2tag(post_id,tag_id) values('$postid','$tagid')";
					$wpdb->query($sql);
				}
				$taglist .= $tagid.",";
			}
			if($taglist == "")
			{
				$sql = "delete from $tafwp->tbpost2tag where post_id = $postid";
			}
			else
			{
				$taglist = substr($taglist, 0 ,-1);
				$sql = "delete from $tafwp->tbpost2tag where post_id = $postid and tag_id not in ($taglist)";
			}
			$wpdb->query($sql);
		}
		
		$sql = "select * from $wpdb->posts p where p.id = $postid and p.post_status = \"publish\" and p.post_type = \"post\"";
		$posts = $wpdb->get_results($sql);
		if($posts)
		{
			$p = $posts[0];
			$time = date("Y-m-d H:i:s",strtotime($p->post_date));
			$excerpt = $tafwp->cut_str(strip_tags($p->post_content),250,"UTF-8");
			$from = get_option('blogname');

			$fp = fsockopen("www.tagally.com", 80, $errno, $errstr, 10);
			if ($fp)
			{
				$post_data = "v=".rawurlencode($version);
				$guid = strip_tags($p->guid);
				$post_data .= '&'."guid=".rawurlencode($guid);
				$from = strip_tags($from);
				$post_data .= '&'."from=".rawurlencode($from);
				$title = strip_tags($p->post_title);
				$post_data .= '&'."posttitle=".rawurlencode($title);
				$excerpt = strip_tags($excerpt);
				$post_data .= '&'."excerpt=".rawurlencode($excerpt);
				$time = strip_tags($time);
				$post_data .= '&'."posttime=".rawurlencode($time);
				$tags = strip_tags(stripslashes($tags));
				$post_data .= '&'."tags=".rawurlencode($tags);
				$post_length = strlen($post_data);
				$out = "POST http://www.tagally.com/main/import HTTP/1.1\r\n";
				$out .= "Host: www.tagally.com\r\n";
				$out .= "Content-Length:$post_length\r\n";
				$out .= "Content-Type:application/x-www-form-urlencoded; charset=utf-8\r\n";
				$out .= "Connection: Close\r\n\r\n";
				$out .= $post_data;
				
				$len = fwrite($fp, $out);
				while (!feof($fp))
				{
					fgets($fp, 128);
				}
				fclose($fp);
			}
			else
			{
//				trigger_error("connect failed");
			}
		}
	}
	
	function delete_post_tags($postid)
	{
			global $wpdb, $tafwp, $version;
			$sql = "select guid from $wpdb->posts where ID = $postid";
			$guid = $wpdb->get_var($sql);
			if(!is_null($guid))
			{
				$fp = fsockopen("www.tagally.com", 80, $errno, $errstr, 30);
				if($fp)
				{
					$post_data = "v=".rawurlencode($version);
					$post_data .= "&guid=".rawurlencode($guid);
					$post_length = strlen($post_data);
					$out = "POST http://www.tagally.com/main/unimport HTTP/1.1\r\n";
					$out .= "Host: www.tagally.com\r\n";
					$out .= "Content-Length:$post_length\r\n";
					$out .= "Content-Type:application/x-www-form-urlencoded; charset=utf-8\r\n";
					$out .= "Connection: Close\r\n\r\n";
					$out .= $post_data;
					
					$len = fwrite($fp, $out);
					while (!feof($fp))
					{
						fgets($fp, 128);
					}
					fclose($fp);
				}
			}
	}
	
	function the_content_tags($thecontent='')
	{
		global $post, $tafwp;
		$tags = $tafwp->GetTagsForPost($post->ID,10);
		$tagsHTML = "";
		if ($tags)
		{
			$tagsHTML .= "tags:";
	
			foreach ($tags as $tag)
			{
				$para = urlencode($tag->slug);
				$tagsHTML .= " <a href=\"$tafwp->siteurl/index.php?"."tag=$para\">".$tag->tag."</a>";
				$tagsHTML .= "&nbsp;&nbsp;";
			}
		}
		else
		{
			$tagsHTML = "No Tag";
		}
		$thecontent = $thecontent.$tagsHTML;
		return $thecontent;
	}
	
	function admin_head_add_javascript()
	{
		global $tafwp;
		$addtagjs = "$tafwp->siteurl/wp-content/plugins$tafwp->install_directory/inserttag-js.php";

		echo "<script src=\"$addtagjs\" type=\"text/javascript\"></script>";
	}
	
	function wp_head_add_javascript()
	{
		global $tafwp;
		
		$shinejs = "$tafwp->siteurl/wp-content/plugins$tafwp->install_directory/uletsshine-js.php";
		$flcs = "$tafwp->siteurl/wp-content/plugins$tafwp->install_directory/fl.css";
		
		echo "<link href=\"$flcs\" rel=\"stylesheet\" type=\"text/css\" />";
		echo "<script src=\"$shinejs\" type=\"text/javascript\"></script>";
	}
	
	
	function wp_footer_add_dropmenu()
	{
			global $tafwp;
			echo <<<DROPMENU
			    <div style="clear:both;"></div>
				  <div id="dropmenu" class="dpmAp" onmouseover="clearhidemenu()" onmouseout="delayhidemenu()" style="left: 0px; top: 0px; visibility: hidden;">
						<div class="dpms0">
								<form onsubmit="" action="" method='post' target='_blank'>
						            <div class="dpms1">
						            	<span class="dpmp1">Tag&nbsp;:&nbsp;</span>
						            	  <a id="tNY6IO" target='_blank' href="#" style="color:#E10000;font-weight:700">tag</a><br/>
						                <a id="tNYIMU" target='_blank' href="http://www.tagally.com/main/addfavorite?tags="><img id="addlist" width="124" height="17"  src="$tafwp->siteurl/wp-content/plugins$tafwp->install_directory/addto.gif" style="padding:2px 0px 0px 0px;margin-top:2px;background:none;border-color:#FFF;border-style:none;border-width:0px;" alt="add this tag to your favorites in TagALLY.com"/></a>
						            </div>
						            <div class="dpms2">
						            	<span class="dpmp1">Latest&nbsp;:&nbsp;</span>
						            	<a id="lastarts" href="#" target='_blank'></a>
						            </div>
						            <div class="dpms3">
						            	<span class="dpmp1">Top Hot&nbsp;:&nbsp;</span>
							            <div id="thehotmore"></div>
						            </div>
						            <div id="tNMODV" style="display:none;float:left;margin:3px;padding:1px;border-bottom:2px solid #FD0;background-color:#FFF;color:#FD0;width:58px">
						            	<strong><a target='_blank' id="tNMOTI" href="#" style="cursor:pointer;" title="go to TagALLY.com to see more">More ...</a></strong>
						            </div>
						            <div class="dpmsfoot" style="margin-top:10px;">
						            	<a style="color:#000040;background-color:#9cf" target='_blank' href="http://www.tagally.com">Powered by  TagALLY.com</a>

						            </div>
						            <div id="liDv"><img style="max-width:none;background:none;border-color:#FFF;border-style:none;border-width:0px;padding:0px;margin:0px" width="33" height="33" src="$tafwp->siteurl/wp-content/plugins$tafwp->install_directory/31.gif"/></div>
					      </form>
					  </div>
					</div>
DROPMENU;
	}
	
	function tag_query_vars($vars)
	{
		$vars[] = 'tag';
		return $vars;
	}
		
	function template_redirect_tag()
	{
		global $tafwp;
		if ($tags = get_query_var("tag"))
		{
			$tafwp->GetPostsForTagTemplates($tags);
		}
	}
	
	function posts_join($joinclause)
	{
		if(get_query_var("tag"))
		{
			global $wpdb, $tafwp;
			$joinclause .= "inner join $tafwp->tbpost2tag p2t on p2t.post_id = $wpdb->posts.ID inner join $tafwp->tbtags t on t.tag_ID = p2t.tag_id";
		}
		return $joinclause;
	}
	
	function posts_where($whereclause)
	{
		if($tags = get_query_var("tag"))
		{
			$tags = str_replace(" ",",",$tags);
			$whereclause .= "and t.slug in ('$tags')";
		}
		return $whereclause;
	}
	
	function posts_orderby($orderbyclause)
	{
		if(get_query_var("tag"))
		{
			$orderbyclause = "post_modified desc";
		}
		return $orderbyclause;
	}
	
	function cut_str($msg,$cut_size,$charset="UTF-8",$suffix="...") 
	{
    if($cut_size<=0) return $msg;
    $i=1;
    while ($i <= strlen($msg))
    {
      //if it is ASCII extended charater
      if(ord($msg[($i-1)])>127)
      {
        $chinese++;
        //if $charset is UTF-8, skip three ASCII
        if($charset=="UTF-8")
        {
          $str .= $msg[($i-1)].$msg[($i)].$msg[($i+1)];
          $i=$i+3;
        }
        else //else skip three ASCII
        {
          $str .= $msg[($i-1)].$msg[($i)];
          $i=$i+2;
        }
      }
      else
      {
        $eng++;
        $str .= $msg[($i-1)];
        $i++;
      }

      if(($chinese+$eng)==$cut_size)
      	break;
    }
    
    $suffix = ($chinese+$eng)<$cut_size?"":$suffix;
    return $str.$suffix;
	}
}
?>
